#!/usr/bin/env python

import hal
import gtk
import glib
import linuxcnc
import serial
import threading
import sys
import time

numerr = 0;
h = hal.component("IRB")
h.newpin("go", hal.HAL_BIT, hal.HAL_IN)
h.ready()

try:
    s = linuxcnc.stat() # create a connection to the status channel
    s.poll() # get current values
except linuxcnc.error, detail:
    print "LINUXCNC error", detail
    sys.exit(1)
#for x in dir(s):
#    if not x.startswith('_'):
#        print x, getattr(s,x)

class myThread (threading.Thread):
    def __init__(self, threadID, name, timeout):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.timeout = timeout
    def run(self):
        print "Starting " + self.name
        modbusInit(self.name, self.timeout)
        print "Exiting " + self.name

def modbusInit(threadName,timeoutIn):
	ser = serial.Serial('/dev/ttyUSB0',timeout = timeoutIn)
	outputByte = 165
	numerr = 0
	inSize = 1
	print "Start Time: %f" % time.time()
	while numerr < 100:
		if h.go == 1:
			print "working thread 1: %f" % time.time()
			#try:
			print "outputByte = %d" % outputByte
			#outCRC = getCRC(outputByte)
			if sendFc16(165,1,2,[102,122],ser) == 1:
			#if writeByte(chr(outputByte),ser) == 1:
				print "inside if"
				#writeByte(chr(65),ser)
				#writeByte(chr(5),ser)
				inputByte = readByte(inSize,ser)
				while len(inputByte)==0:
					#print "written"
					#time.sleep(0.5)
					inputByte = readByte(inSize,ser)
				print "direct input =" + inputByte
				print "inputByte = %d" % ord(inputByte) 
				#outputByte += 1
			#except:
			#	print "Comm Error"
		
			#checkCRC()
			if ord(inputByte) != outputByte:
				numerr += 1
	ser.close()

def writeByte(outByte,outPort):
	#outPort.flushInput()
	#outPort.flushOutput()
	return outPort.write(outByte)
	
def readByte(readSize,readPort):
	return readPort.read(readSize)
	
def getCRC(outMessage):
	CRCFull = 0xFFFF;
	CRC = bytearray(2);
	for i in range(0,len(outMessage)-2):
		CRCFull = CRCFull ^ outMessage[i]
		#print "CRCFull1 =" + bin(CRCFull) + "i = %d" % i 
		#CRCFull = CRCFull % 2**16
		for j in range(0,8):
			CRCLSB = CRCFull & 0x0001
			CRCFull = (CRCFull >> 1) & 0x7FFF
			#print "CRCFull2 =" + bin(CRCFull) + "CRCLSB = %d" % CRCLSB
			#CRCFull = CRCFull % 2**16
			if CRCLSB==1:
				CRCFull = CRCFull ^ 0xA001
				#print "CRCFull3 =" + bin(CRCFull) 
				#CRCFull = CRCFull % 2**16
	CRC[1] = (CRCFull >> 8) & 0xFF
	CRC[0] = CRCFull & 0xFF
	return CRC

def buildMessage(address,type,start,registers,message):
	message[0] = address
	message[1] = type
	message[2] = start >> 8
	message[3] = start
	message[4] = registers >> 8
	message[5] = registers
	outputCRC = getCRC(message)
	print "mess0 is: %d" % message[0]
	print "mess1 is: %d" % message[1]
	print "mess2 is: %d" % message[2]
	print "mess3 is: %d" % message[3]
	print "mess4 is: %d" % message[4]
	print "mess5 is: %d" % message[5]
	print "mess6 is: %d" % message[6]
	print "mess7 is: %d" % message[7]
	print "mess8 is: %d" % message[8]
	print "mess9 is: %d" % message[9]
	print "mess10 is: %d" % message[10]
	message[len(message)-2] = outputCRC[0]
	message[len(message)-1] = outputCRC[1]
	print "CRC0 is: %d" % message[11]
	print "CRC1 is: %d" % message[12]
	
def sendFc16(address,start,registers,values,port):	
	if port.isOpen():
		port.flushInput()
		port.flushOutput()
		message = bytearray(9 + 2 * registers)
		response = bytearray(8)
		message[6] = registers * 2
		for i in range(0,registers):
			message[7 + 2*i] = values[i] >> 8
			message[8 + 2*i] = values[i]
			#print "i = %d" % i
		buildMessage(address,16,start,registers,message)
		print "message length = %d" % len(message)
		writeMessage(port,message)
		response = getResponse(port)
		
	return 1

def writeMessage(port,message):
	for i in range(0,len(message)):
		writeByte(chr(message[i]),port)
		#print "chrmess " + chr(message[i])

def getResponse(port):
	response = bytearray(8)
	for i in range(0,8):
		response[i] = readByte(1,port)
	return response

def checkResponse(response):
	CRC = getCRC(response)
	return CRC[0] == response[len(response) - 2] && CRC[1] == response[len(response) - 1]
	
class HandlerClass:

	def __init__(self,halcomp,builder,useropts):
		filename = "/home/stan/Documents/gladetests/test1.ui"
		builder = gtk.Builder()
		builder.add_from_file(filename)
		builder.connect_signals(self)        

	def on_hal_led1_hal_pin_changed(self,hal_led1,data=None):
		n = 0
		#while True:
		#ser = serial.Serial('/dev/ttyUSB0')
		#ser.open()
	 	#ser.write('1')
	 	#print ser.read(2)
	 	#ser.close()
	     
	def on_hal_button1_pressed(self,hal_button1,data=None):
		#n = 0
		#print "%f" % n
		#nhits += 1 
		#hal_label1.set_label("hits: %d" % nhits)
		hal_button1.set_label("aha!")
		
		#ser = serial.Serial('/dev/ttyUSB0')
		#ser.open()
		#while ser.read(1):	
		#	ser.write('1')
		#ser.close()
		
		#ser = serial.Serial('/dev/ttyUSB0')
		#ser.open()
		#ser.write('ACK')
		#print ser.read(2)
		
 		#n = ser.read(2)
 		#print n
 		#if n == 5:
		#	ser.write('ACK')
		#	print ser.read(13)
		
		#ser.close()
    
def get_handlers(halcomp,builder,useropts):
	for cmd in useropts:
		exec cmd in globals()
	return [HandlerClass(halcomp,builder,useropts)]
	
thread1 = myThread(1,"Modbus-Thread-1",0.5)
thread1.start()

print "Exiting Main Thread"
