#!/usr/bin/env python

import hal
import gtk
import glib
import linuxcnc
import serial
import threading
import sys
import time

numerr = 0;
h = hal.component("IRB")
h.newpin("go", hal.HAL_BIT, hal.HAL_IN)
h.ready()

try:
    s = linuxcnc.stat() # create a connection to the status channel
    s.poll() # get current values
except linuxcnc.error, detail:
    print "LINUXCNC error", detail
    sys.exit(1)
#for x in dir(s):
#    if not x.startswith('_'):
#        print x, getattr(s,x)

class myThread (threading.Thread):
    def __init__(self, threadID, name, timeout):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.timeout = timeout
    def run(self):
        print "Starting " + self.name
        modbusInit(self.name, self.timeout)
        print "Exiting " + self.name

def modbusInit(threadName,timeoutIn):
	ser = serial.Serial('/dev/ttyUSB0',timeout = timeoutIn)
	#ser.open()
	outputByte = 100
	#inputByte = chr(0)
	#ReadySignal = 1
	numerr = 0
	inSize = 1
	print "Start Time: %f" % time.time()
	while numerr < 100:
		#writeByte(chr(outputByte),ser)
		#time.sleep(1)
		#inputByte = readByte(inSize,ser)
		#print "direct input =" + inputByte
		#print "inputByte = %d" % ord(inputByte)
		if h.go == 1:
			print "working thread 1: %f" % time.time()
			#try:
			print "outputByte = %d" % outputByte
			if writeByte(chr(outputByte),ser) == 1:
				#writeByte(chr(outputByte+10),ser)
				#writeByte(chr(outputByte+20),ser)
				inputByte = readByte(inSize,ser)
				while (inputByte=="U") or (len(inputByte)==0):
					print "written"
					time.sleep(0.5)
					inputByte = readByte(inSize,ser)
				print "direct input =" + inputByte
				print "inputByte = %d" % ord(inputByte) 
				outputByte += 1
			#except:
			#	print "Comm Error"
		
			#checkCRC()
			if inputByte != outputByte:
				numerr += 1
	ser.close()

def writeByte(outByte,outPort):
	return outPort.write(outByte)
	
def readByte(readSize,readPort):
	return readPort.read(readSize)

class HandlerClass:

	def __init__(self,halcomp,builder,useropts):
		filename = "/home/stan/Documents/gladetests/test1.ui"
		builder = gtk.Builder()
		builder.add_from_file(filename)
		builder.connect_signals(self)        

	def on_hal_led1_hal_pin_changed(self,hal_led1,data=None):
		n = 0
		#while True:
		#ser = serial.Serial('/dev/ttyUSB0')
		#ser.open()
	 	#ser.write('1')
	 	#print ser.read(2)
	 	#ser.close()
	     
	def on_hal_button1_pressed(self,hal_button1,data=None):
		#n = 0
		#print "%f" % n
		#nhits += 1 
		#hal_label1.set_label("hits: %d" % nhits)
		hal_button1.set_label("aha!")
		
		#ser = serial.Serial('/dev/ttyUSB0')
		#ser.open()
		#while ser.read(1):	
		#	ser.write('1')
		#ser.close()
		
		#ser = serial.Serial('/dev/ttyUSB0')
		#ser.open()
		#ser.write('ACK')
		#print ser.read(2)
		
 		#n = ser.read(2)
 		#print n
 		#if n == 5:
		#	ser.write('ACK')
		#	print ser.read(13)
		
		#ser.close()
    
def get_handlers(halcomp,builder,useropts):
	for cmd in useropts:
		exec cmd in globals()
	return [HandlerClass(halcomp,builder,useropts)]
	
thread1 = myThread(1,"Modbus-Thread-1",0.5)
thread1.start()

print "Exiting Main Thread"
